from utils import validatepolicy
from env import ContinuousBuildingControlEnvironment as BEnv
import pandas as pd

if __name__ == '__main__':
    # Validate SARSA
    # start environment
    data_file = 'weather_data_2010_to_2018_summer_pandas.csv'
    Q = pd.read_csv("Q_SARSA.csv", index_col=0)
    Q.index = [eval(i) for i in Q.index]
    Q.columns = [eval(c) for c in Q.columns]
    online_start = 17664.
    online_end = 19872.5
    print("Validate policy of SARSA: ")
    env = BEnv(data_file,
               start=online_start,
               end=online_end,
               C_env=3.1996e6,
               C_air=3.5187e5,
               R_rc=0.00706,
               R_oe=0.02707,
               R_er=0.00369)
    energy_list, penalty_list = validatepolicy(env, Q, online_start,
                                               online_end, title='SARSA')
    print("The energy consumption per day is ",
          sum(energy_list)/len(energy_list)*48*1000)
    print("The temperature violation is per hour is ",
          sum(penalty_list)/len(penalty_list))
    # Validate Q-learning
    print("Validate policy of Q-learning: ")
    Q_lr = pd.read_csv("Q_lr.csv", index_col=0)
    Q_lr.index = [eval(i) for i in Q_lr.index]
    Q_lr.columns = [eval(c) for c in Q_lr.columns]
    energy_list, penalty_list = validatepolicy(env, Q, online_start,
                                               online_end, title='Q_lr')
    print("The energy consumption per day is ",
          sum(energy_list)/len(energy_list)*48*1000)
    print("The temperature violation is per hour is ",
          sum(penalty_list)/len(penalty_list))
